package ru.landgrafhomyak.serdha.api.v0

import ru.landgrafhomyak.serdha.api.v0.ddl.ColumnType

public interface Expression<RuntimeType, DatabaseType : ColumnType<RuntimeType>, OwnerBuilderUserExtension : Any> {
	public interface Builder<OwnerBuilderUserExtension : Any> {
		public fun <RuntimeType, DatabaseType : ColumnType<RuntimeType>> equals(
			left: Expression<RuntimeType, DatabaseType, OwnerBuilderUserExtension>,
			right: Expression<RuntimeType, DatabaseType, OwnerBuilderUserExtension>,
		): Expression<Boolean, ColumnType.BOOLEAN, OwnerBuilderUserExtension>

		public fun isNull(
			e: Expression<*, ColumnType.Nullable<*, *>, OwnerBuilderUserExtension>,
		): Expression<Boolean, ColumnType.BOOLEAN, OwnerBuilderUserExtension>

		public fun isNotNull(
			e: Expression<*, ColumnType.Nullable<*, *>, OwnerBuilderUserExtension>,
		): Expression<Boolean, ColumnType.BOOLEAN, OwnerBuilderUserExtension>
	}
}