package ru.landgrafhomyak.serdha.api.v0.ddl

import kotlin.jvm.JvmStatic

public interface ForeignKey<ContainerTableUserExtension : Any, TargetTableUserExtension : Any> {
	public val fromTable: Table<ContainerTableUserExtension, *>
	public val fromColumns: List<Column<*, *, ContainerTableUserExtension>>
	public val toTable: Table<TargetTableUserExtension, *>
	public val toColumns: List<Column<*, *, TargetTableUserExtension>>

	public enum class OnUpdateAction {
		NO_ACTION,
		RESTRICT,
		SET_NULL,
		SET_DEFAULT,
		CASCADE
	}

	public enum class OnDeleteAction {
		NO_ACTION,
		RESTRICT,
		SET_NULL,
		SET_DEFAULT,
		CASCADE
	}

	public companion object {
		@JvmStatic
		public val DEFAULT_ON_UPDATE_ACTION: OnUpdateAction
			inline get() = OnUpdateAction.CASCADE

		@JvmStatic
		public val DEFAULT_ON_DELETE_ACTION: OnDeleteAction
			inline get() = OnDeleteAction.RESTRICT
	}
}