package ru.landgrafhomyak.serdha.api.v0.runtime

import ru.landgrafhomyak.serdha.api.v0.LowLevelApi
import ru.landgrafhomyak.serdha.api.v0.ddl.Module
import ru.landgrafhomyak.serdha.api.v0.dml.Delete
import ru.landgrafhomyak.serdha.api.v0.dml.Insert
import ru.landgrafhomyak.serdha.api.v0.dml.InsertCreator
import ru.landgrafhomyak.serdha.api.v0.dml.Select
import ru.landgrafhomyak.serdha.api.v0.dml.Update

public interface SynchronizedDatabase<DatabaseUserExtension : Any> : Module<DatabaseUserExtension> {
	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun _startTransaction(): Transaction

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <QueryUserWrapper : Any> _autoTransactedSelect(query: Select<QueryUserWrapper>): _ParametersSetter<QueryUserWrapper, _ResultSet<QueryUserWrapper, Unit>>

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <QueryUserWrapper : Any> _autoTransactedInsertParams(query: Insert.InsertParams<QueryUserWrapper>): _ParametersSetter<QueryUserWrapper, _ParametersSetter._Multi<InsertCreator.InsertParams.DataParam<QueryUserWrapper>, _ResultSet<QueryUserWrapper, _ResultSet<QueryUserWrapper, Unit>>?>>

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <QueryUserWrapper : Any> _autoTransactedInsertFromQuery(query: Insert.InsertFromQuery<QueryUserWrapper>): _ParametersSetter<QueryUserWrapper, _ResultSet<QueryUserWrapper, _ResultSet<QueryUserWrapper, Unit>>?>

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <QueryUserWrapper : Any> _autoTransactedUpdate(query: Update<QueryUserWrapper>): _ParametersSetter<QueryUserWrapper, _ResultSet<QueryUserWrapper, Unit>?>

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <QueryUserWrapper : Any> _autoTransactedDelete(query: Delete<QueryUserWrapper>): _ParametersSetter<QueryUserWrapper, _ResultSet<QueryUserWrapper, Unit>?>

	public interface AtomicScript<C, A, R> {
		public suspend fun executeTransaction(transaction: Transaction, context: C, args: A): R
	}

	public suspend fun <C, A, R> transaction(script: AtomicScript<C, A, R>, context: C, args: A): R

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun _close()
}